## webkit2gtk 2.44.2

=== Source/JavaScriptCore/CMakeLists.txt ===
set_property(DIRECTORY . PROPERTY FOLDER "JavaScriptCore")

list(APPEND JavaScriptCore_UNIFIED_SOURCE_LIST_FILES
    "Sources.txt"
)

set(JavaScriptCore_INCLUDE_DIRECTORIES
    "${JavaScriptCore_FRAMEWORK_HEADERS_DIR}"
)

set(JavaScriptCore_PRIVATE_INCLUDE_DIRECTORIES
    "${CMAKE_BINARY_DIR}"
    "${JAVASCRIPTCORE_DIR}"
    "${JAVASCRIPTCORE_DIR}/API"
    "${JAVASCRIPTCORE_DIR}/assembler"
    "${JAVASCRIPTCORE_DIR}/b3"
    "${JAVASCRIPTCORE_DIR}/b3/air"
    "${JAVASCRIPTCORE_DIR}/bindings"
    "${JAVASCRIPTCORE_DIR}/builtins"
    "${JAVASCRIPTCORE_DIR}/bytecode"
    "${JAVASCRIPTCORE_DIR}/bytecompiler"
    "${JAVASCRIPTCORE_DIR}/dfg"
    "${JAVASCRIPTCORE_DIR}/disassembler"
    "${JAVASCRIPTCORE_DIR}/disassembler/ARM64"
    "${JAVASCRIPTCORE_DIR}/disassembler/zydis/Zydis"
    "${JAVASCRIPTCORE_DIR}/domjit"
    "${JAVASCRIPTCORE_DIR}/ftl"
    "${JAVASCRIPTCORE_DIR}/fuzzilli"
    "${JAVASCRIPTCORE_DIR}/heap"
    "${JAVASCRIPTCORE_DIR}/debugger"
    "${JAVASCRIPTCORE_DIR}/inspector"
    "${JAVASCRIPTCORE_DIR}/inspector/agents"
    "${JAVASCRIPTCORE_DIR}/inspector/augmentable"
    "${JAVASCRIPTCORE_DIR}/inspector/remote"
    "${JAVASCRIPTCORE_DIR}/interpreter"
    "${JAVASCRIPTCORE_DIR}/jit"
    "${JAVASCRIPTCORE_DIR}/llint"
    "${JAVASCRIPTCORE_DIR}/parser"
    "${JAVASCRIPTCORE_DIR}/profiler"
    "${JAVASCRIPTCORE_DIR}/runtime"
    "${JAVASCRIPTCORE_DIR}/tools"
    "${JAVASCRIPTCORE_DIR}/wasm"
    "${JAVASCRIPTCORE_DIR}/wasm/js"
    "${JAVASCRIPTCORE_DIR}/yarr"
    "${JavaScriptCore_DERIVED_SOURCES_DIR}"
    "${JavaScriptCore_DERIVED_SOURCES_DIR}/inspector"
    "${JavaScriptCore_DERIVED_SOURCES_DIR}/runtime"
    "${JavaScriptCore_DERIVED_SOURCES_DIR}/yarr"
)

if (USE_CAPSTONE)
    list(APPEND JavaScriptCore_PRIVATE_INCLUDE_DIRECTORIES "${THIRDPARTY_DIR}/capstone/Source/include")
endif ()

set(JavaScriptCore_OBJECT_LUT_SOURCES
    runtime/ArrayConstructor.cpp
    runtime/AsyncFromSyncIteratorPrototype.cpp
    runtime/AsyncGeneratorPrototype.cpp
    runtime/BigIntConstructor.cpp
    runtime/BigIntPrototype.cpp
    runtime/BooleanPrototype.cpp
    runtime/DateConstructor.cpp
    runtime/DatePrototype.cpp
    runtime/ErrorPrototype.cpp
    runtime/GeneratorPrototype.cpp
    runtime/IntlCollatorConstructor.cpp
    runtime/IntlCollatorPrototype.cpp
    runtime/IntlDateTimeFormatConstructor.cpp
    runtime/IntlDateTimeFormatPrototype.cpp
    runtime/IntlDisplayNamesConstructor.cpp
    runtime/IntlDisplayNamesPrototype.cpp
    runtime/IntlDurationFormatConstructor.cpp
    runtime/IntlDurationFormatPrototype.cpp
    runtime/IntlListFormatConstructor.cpp
    runtime/IntlListFormatPrototype.cpp
    runtime/IntlLocalePrototype.cpp
    runtime/IntlNumberFormatConstructor.cpp
    runtime/IntlNumberFormatPrototype.cpp
    runtime/IntlObject.cpp
    runtime/IntlPluralRulesConstructor.cpp
    runtime/IntlPluralRulesPrototype.cpp
    runtime/IntlRelativeTimeFormatConstructor.cpp
    runtime/IntlRelativeTimeFormatPrototype.cpp
    runtime/IntlSegmentIteratorPrototype.cpp
    runtime/IntlSegmenterConstructor.cpp
    runtime/IntlSegmenterPrototype.cpp
    runtime/IntlSegmentsPrototype.cpp
    runtime/JSDataViewPrototype.cpp
    runtime/JSGlobalObject.cpp
    runtime/JSInternalPromiseConstructor.cpp
    runtime/JSONObject.cpp
    runtime/JSPromiseConstructor.cpp
    runtime/JSPromisePrototype.cpp
    runtime/MapConstructor.cpp
    runtime/MapPrototype.cpp
    runtime/NumberConstructor.cpp
    runtime/NumberPrototype.cpp
    runtime/ObjectConstructor.cpp
    runtime/ReflectObject.cpp
    runtime/RegExpConstructor.cpp
    runtime/RegExpPrototype.cpp
    runtime/RegExpStringIteratorPrototype.cpp
    runtime/SetPrototype.cpp
    runtime/ShadowRealmObject.cpp
    runtime/ShadowRealmPrototype.cpp
    runtime/StringConstructor.cpp
    runtime/StringPrototype.cpp
    runtime/SymbolConstructor.cpp
    runtime/SymbolPrototype.cpp
    runtime/TemporalCalendarConstructor.cpp
    runtime/TemporalCalendarPrototype.cpp
    runtime/TemporalDurationConstructor.cpp
    runtime/TemporalDurationPrototype.cpp
    runtime/TemporalInstantConstructor.cpp
    runtime/TemporalInstantPrototype.cpp
    runtime/TemporalNow.cpp
    runtime/TemporalObject.cpp
    runtime/TemporalPlainDateConstructor.cpp
    runtime/TemporalPlainDatePrototype.cpp
    runtime/TemporalPlainDateTimeConstructor.cpp
    runtime/TemporalPlainDateTimePrototype.cpp
    runtime/TemporalPlainTimeConstructor.cpp
    runtime/TemporalPlainTimePrototype.cpp
    runtime/TemporalTimeZoneConstructor.cpp
    runtime/TemporalTimeZonePrototype.cpp

    wasm/js/JSWebAssembly.cpp
    wasm/js/WebAssemblyArrayConstructor.cpp
    wasm/js/WebAssemblyArrayPrototype.cpp
    wasm/js/WebAssemblyCompileErrorConstructor.cpp
    wasm/js/WebAssemblyCompileErrorPrototype.cpp
    wasm/js/WebAssemblyExceptionConstructor.cpp
    wasm/js/WebAssemblyExceptionPrototype.cpp
    wasm/js/WebAssemblyGlobalConstructor.cpp
    wasm/js/WebAssemblyGlobalPrototype.cpp
    wasm/js/WebAssemblyInstanceConstructor.cpp
    wasm/js/WebAssemblyInstancePrototype.cpp
    wasm/js/WebAssemblyLinkErrorConstructor.cpp
    wasm/js/WebAssemblyLinkErrorPrototype.cpp
    wasm/js/WebAssemblyMemoryConstructor.cpp
    wasm/js/WebAssemblyMemoryPrototype.cpp
    wasm/js/WebAssemblyModuleConstructor.cpp
    wasm/js/WebAssemblyModulePrototype.cpp
    wasm/js/WebAssemblyRuntimeErrorConstructor.cpp
    wasm/js/WebAssemblyRuntimeErrorPrototype.cpp
    wasm/js/WebAssemblyStructConstructor.cpp
    wasm/js/WebAssemblyStructPrototype.cpp
    wasm/js/WebAssemblyTableConstructor.cpp
    wasm/js/WebAssemblyTablePrototype.cpp
    wasm/js/WebAssemblyTagConstructor.cpp
    wasm/js/WebAssemblyTagPrototype.cpp
)

list(APPEND JavaScriptCore_SOURCES
    runtime/CachedTypes.cpp
    ${JavaScriptCore_DERIVED_SOURCES_DIR}/JSCBytecodeCacheVersion.cpp
    ${JavaScriptCore_DERIVED_SOURCES_DIR}/JSCBuiltins.cpp
)

find_program(TOUCH_EXECUTABLE touch)
if (TOUCH_EXECUTABLE)
    add_custom_command(
        OUTPUT ${JavaScriptCore_DERIVED_SOURCES_DIR}/JSCBytecodeCacheVersion.cpp
        MAIN_DEPENDENCY ${JAVASCRIPTCORE_DIR}/runtime/JSCBytecodeCacheVersion.cpp.in
        COMMAND ${PERL_EXECUTABLE} -pe s/CACHED_TYPES_CKSUM/__TIMESTAMP__/ ${JAVASCRIPTCORE_DIR}/runtime/JSCBytecodeCacheVersion.cpp.in > ${JavaScriptCore_DERIVED_SOURCES_DIR}/JSCBytecodeCacheVersion.cpp
        COMMAND ${TOUCH_EXECUTABLE} -r ${JAVASCRIPTCORE_DIR}/runtime/JSCBytecodeCacheVersion.cpp.in ${JavaScriptCore_DERIVED_SOURCES_DIR}/JSCBytecodeCacheVersion.cpp
            VERBATIM
    )
else ()
    message(WARNING "Unable to find touch executable; ${JavaScriptCore_DERIVED_SOURCES_DIR}/JSCBytecodeCacheVersion.cpp is built non-reproducibly from ${JAVASCRIPTCORE_DIR}/runtime/JSCBytecodeCacheVersion.cpp.in")
    add_custom_command(
        OUTPUT ${JavaScriptCore_DERIVED_SOURCES_DIR}/JSCBytecodeCacheVersion.cpp
        MAIN_DEPENDENCY ${JAVASCRIPTCORE_DIR}/runtime/JSCBytecodeCacheVersion.cpp.in
        COMMAND ${PERL_EXECUTABLE} -pe s/CACHED_TYPES_CKSUM/__TIMESTAMP__/ ${JAVASCRIPTCORE_DIR}/runtime/JSCBytecodeCacheVersion.cpp.in > ${JavaScriptCore_DERIVED_SOURCES_DIR}/JSCBytecodeCacheVersion.cpp
            VERBATIM
    )
endif ()

set(JavaScriptCore_FRAMEWORKS
    WTF
)
if (NOT USE_SYSTEM_MALLOC)
    list(APPEND JavaScriptCore_FRAMEWORKS bmalloc)
endif ()

if (USE_CAPSTONE)
    list(APPEND JavaScriptCore_LIBRARIES capstone)
endif ()

if (ATOMICS_REQUIRE_LIBATOMIC)
    list(APPEND JavaScriptCore_LIBRARIES atomic)
endif ()

set(JavaScriptCore_SCRIPTS_SOURCES_DIR "${JAVASCRIPTCORE_DIR}/Scripts")

# Globbing relies on the fact that generator-specific file names are prefixed with their directory.
# Top-level scripts should have a file extension, since they are invoked during the build.

set(JavaScriptCore_SCRIPTS_SOURCES_PATHS
    ${JavaScriptCore_SCRIPTS_SOURCES_DIR}/*.pl
    ${JavaScriptCore_SCRIPTS_SOURCES_DIR}/*.py
    ${JavaScriptCore_SCRIPTS_SOURCES_DIR}/wkbuiltins/builtins*.py
    ${JavaScriptCore_SCRIPTS_SOURCES_DIR}/wkbuiltins/wkbuiltins.py
)

# The directory flattening performed below mirrors what the Mac port does with private headers.

file(GLOB JavaScriptCore_SCRIPTS_SOURCES ${JavaScriptCore_SCRIPTS_SOURCES_PATHS})

foreach (_file ${JavaScriptCore_SCRIPTS_SOURCES})
    get_filename_component(_script "${_file}" NAME)
    add_custom_command(
        OUTPUT ${JavaScriptCore_SCRIPTS_DIR}/${_script}
        MAIN_DEPENDENCY ${_file}
        WORKING_DIRECTORY ${JavaScriptCore_DERIVED_SOURCES_DIR}
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${_file} ${JavaScriptCore_SCRIPTS_DIR}/${_script}
        VERBATIM)
    list(APPEND JavaScriptCore_SCRIPTS ${JavaScriptCore_SCRIPTS_DIR}/${_script})
endforeach ()

# This is the default build variant for Xcode builds.
set(BUILD_VARIANTS
    "normal"
)

set(LLINT_ASM
    llint/InPlaceInterpreter.asm
    llint/LowLevelInterpreter.asm
    llint/LowLevelInterpreter32_64.asm
    llint/LowLevelInterpreter64.asm
    llint/WebAssembly.asm
    llint/WebAssembly32_64.asm
    llint/WebAssembly64.asm
)

set(OFFLINE_ASM
    offlineasm/arm.rb
    offlineasm/arm64.rb
    offlineasm/arm64e.rb
    offlineasm/asm.rb
    offlineasm/ast.rb
    offlineasm/backends.rb
    offlineasm/cloop.rb
    offlineasm/config.rb
    offlineasm/instructions.rb
    offlineasm/offsets.rb
    offlineasm/opt.rb
    offlineasm/parser.rb
    offlineasm/registers.rb
    offlineasm/risc.rb
    offlineasm/riscv64.rb
    offlineasm/self_hash.rb
    offlineasm/settings.rb
    offlineasm/transform.rb
    offlineasm/x86.rb
)

set(GENERATOR
    generator/Argument.rb
    generator/Assertion.rb
    generator/Checkpoints.rb
    generator/DSL.rb
    generator/Fits.rb
    generator/GeneratedFile.rb
    generator/Metadata.rb
    generator/Opcode.rb
    generator/OpcodeGroup.rb
    generator/Options.rb
    generator/Section.rb
    generator/Template.rb
    generator/Type.rb
    generator/Wasm.rb
    generator/main.rb
)

add_custom_command(
    OUTPUT ${JavaScriptCore_DERIVED_SOURCES_DIR}/Bytecodes.h ${JavaScriptCore_DERIVED_SOURCES_DIR}/InitBytecodes.asm ${JavaScriptCore_DERIVED_SOURCES_DIR}/BytecodeStructs.h ${JavaScriptCore_DERIVED_SOURCES_DIR}/BytecodeIndices.h ${JavaScriptCore_DERIVED_SOURCES_DIR}/WasmLLIntGeneratorInlines.h ${JavaScriptCore_DERIVED_SOURCES_DIR}/InitWasm.asm ${JavaScriptCore_DERIVED_SOURCES_DIR}/BytecodeDumperGenerated.cpp
    MAIN_DEPENDENCY ${JAVASCRIPTCORE_DIR}/generator/main.rb
    DEPENDS ${GENERATOR} bytecode/BytecodeList.rb ${JAVASCRIPTCORE_DIR}/wasm/wasm.json
    COMMAND ${RUBY_EXECUTABLE} ${JAVASCRIPTCORE_DIR}/generator/main.rb --bytecodes_h ${JavaScriptCore_DERIVED_SOURCES_DIR}/Bytecodes.h --init_bytecodes_asm ${JavaScriptCore_DERIVED_SOURCES_DIR}/InitBytecodes.asm --bytecode_structs_h ${JavaScriptCore_DERIVED_SOURCES_DIR}/BytecodeStructs.h --bytecode_indices_h ${JavaScriptCore_DERIVED_SOURCES_DIR}/BytecodeIndices.h ${JAVASCRIPTCORE_DIR}/bytecode/BytecodeList.rb --wasm_json ${JAVASCRIPTCORE_DIR}/wasm/wasm.json --wasm_llint_generator_h ${JavaScriptCore_DERIVED_SOURCES_DIR}/WasmLLIntGeneratorInlines.h --init_wasm_llint ${JavaScriptCore_DERIVED_SOURCES_DIR}/InitWasm.asm --bytecode_dumper ${JavaScriptCore_DERIVED_SOURCES_DIR}/BytecodeDumperGenerated.cpp
    VERBATIM)
add_custom_target(Bytecodes DEPENDS "${JavaScriptCore_DERIVED_SOURCES_DIR}/Bytecodes.h")

string(TIMESTAMP BUILD_TIME "%s")

list(APPEND JavaScriptCore_HEADERS
    ${JavaScriptCore_DERIVED_SOURCES_DIR}/BytecodeStructs.h
    ${JavaScriptCore_DERIVED_SOURCES_DIR}/Bytecodes.h
)

if (WIN32)
    if (WTF_CPU_X86)
        set(OFFLINE_ASM_BACKEND "X86_WIN")
    elseif (WTF_CPU_X86_64)
        set(OFFLINE_ASM_BACKEND "X86_64_WIN")
    endif ()

    if (NOT ENABLE_JIT)
        if (ENABLE_C_LOOP)
            set(OFFLINE_ASM_BACKEND "C_LOOP_WIN")
        endif ()
    endif ()
else ()
    if (WTF_CPU_X86)
        set(OFFLINE_ASM_BACKEND "X86")
    elseif (WTF_CPU_X86_64)
        set(OFFLINE_ASM_BACKEND "X86_64")
    elseif (WTF_CPU_ARM64)
        set(OFFLINE_ASM_BACKEND "ARM64")
    elseif (ARM_THUMB2_DETECTED)

=== Source/bmalloc/CMakeLists.txt ===
set_property(DIRECTORY . PROPERTY FOLDER "bmalloc")

set(bmalloc_PRIVATE_INCLUDE_DIRECTORIES
    "${BMALLOC_DIR}"
    "${BMALLOC_DIR}/bmalloc"
    "${BMALLOC_DIR}/libpas/src/libpas"
)

set(bmalloc_SOURCES
    bmalloc/AllIsoHeaps.cpp
    bmalloc/Allocator.cpp
    bmalloc/AvailableMemory.cpp
    bmalloc/Cache.cpp
    bmalloc/CryptoRandom.cpp
    bmalloc/Deallocator.cpp
    bmalloc/DebugHeap.cpp
    bmalloc/Environment.cpp
    bmalloc/FreeList.cpp
    bmalloc/Gigacage.cpp
    bmalloc/Heap.cpp
    bmalloc/HeapConstants.cpp
    bmalloc/HeapKind.cpp
    bmalloc/IsoHeap.cpp
    bmalloc/IsoHeapImpl.cpp
    bmalloc/IsoMallocFallback.cpp
    bmalloc/IsoPage.cpp
    bmalloc/IsoSharedHeap.cpp
    bmalloc/IsoSharedPage.cpp
    bmalloc/IsoTLS.cpp
    bmalloc/IsoTLSEntry.cpp
    bmalloc/IsoTLSLayout.cpp
    bmalloc/LargeMap.cpp
    bmalloc/Logging.cpp
    bmalloc/Mutex.cpp
    bmalloc/ObjectType.cpp
    bmalloc/ObjectTypeTable.cpp
    bmalloc/PerProcess.cpp
    bmalloc/Scavenger.cpp
    bmalloc/bmalloc.cpp

    libpas/src/libpas/bmalloc_heap.c
    libpas/src/libpas/bmalloc_heap_config.c
    libpas/src/libpas/bmalloc_type.c
    libpas/src/libpas/hotbit_heap.c
    libpas/src/libpas/hotbit_heap_config.c
    libpas/src/libpas/iso_heap.c
    libpas/src/libpas/iso_heap_config.c
    libpas/src/libpas/iso_test_heap.c
    libpas/src/libpas/iso_test_heap_config.c
    libpas/src/libpas/jit_heap.c
    libpas/src/libpas/jit_heap_config.c
    libpas/src/libpas/minalign32_heap.c
    libpas/src/libpas/minalign32_heap_config.c
    libpas/src/libpas/pagesize64k_heap.c
    libpas/src/libpas/pagesize64k_heap_config.c
    libpas/src/libpas/pas_alignment.c
    libpas/src/libpas/pas_all_heaps.c
    libpas/src/libpas/pas_allocation_callbacks.c
    libpas/src/libpas/pas_allocation_result.c
    libpas/src/libpas/pas_all_shared_page_directories.c
    libpas/src/libpas/pas_baseline_allocator.c
    libpas/src/libpas/pas_baseline_allocator_table.c
    libpas/src/libpas/pas_basic_heap_config_enumerator_data.c
    libpas/src/libpas/pas_bitfit_allocator.c
    libpas/src/libpas/pas_bitfit_directory.c
    libpas/src/libpas/pas_bitfit_heap.c
    libpas/src/libpas/pas_bitfit_page.c
    libpas/src/libpas/pas_bitfit_page_config_kind.c
    libpas/src/libpas/pas_bitfit_size_class.c
    libpas/src/libpas/pas_bitfit_view.c
    libpas/src/libpas/pas_bootstrap_free_heap.c
    libpas/src/libpas/pas_bootstrap_heap_page_provider.c
    libpas/src/libpas/pas_coalign.c
    libpas/src/libpas/pas_commit_span.c
    libpas/src/libpas/pas_committed_pages_vector.c
    libpas/src/libpas/pas_compact_bootstrap_free_heap.c
    libpas/src/libpas/pas_compact_expendable_memory.c
    libpas/src/libpas/pas_compact_heap_reservation.c
    libpas/src/libpas/pas_compact_large_utility_free_heap.c
    libpas/src/libpas/pas_compute_summary_object_callbacks.c
    libpas/src/libpas/pas_create_basic_heap_page_caches_with_reserved_memory.c
    libpas/src/libpas/pas_deallocate.c
    libpas/src/libpas/pas_debug_spectrum.c
    libpas/src/libpas/pas_deferred_decommit_log.c
    libpas/src/libpas/pas_designated_intrinsic_heap.c
    libpas/src/libpas/pas_dyld_state.c
    libpas/src/libpas/pas_dynamic_primitive_heap_map.c
    libpas/src/libpas/pas_ensure_heap_forced_into_reserved_memory.c
    libpas/src/libpas/pas_ensure_heap_with_page_caches.c
    libpas/src/libpas/pas_enumerable_page_malloc.c
    libpas/src/libpas/pas_enumerable_range_list.c
    libpas/src/libpas/pas_enumerate_bitfit_heaps.c
    libpas/src/libpas/pas_enumerate_initially_unaccounted_pages.c
    libpas/src/libpas/pas_enumerate_large_heaps.c
    libpas/src/libpas/pas_enumerate_segregated_heaps.c
    libpas/src/libpas/pas_enumerate_unaccounted_pages_as_meta.c
    libpas/src/libpas/pas_enumerator.c
    libpas/src/libpas/pas_enumerator_region.c
    libpas/src/libpas/pas_epoch.c
    libpas/src/libpas/pas_exclusive_view_template_memo_table.c
    libpas/src/libpas/pas_expendable_memory.c
    libpas/src/libpas/pas_extended_gcd.c
    libpas/src/libpas/pas_fast_large_free_heap.c
    libpas/src/libpas/pas_fast_megapage_cache.c
    libpas/src/libpas/pas_fast_megapage_table.c
    libpas/src/libpas/pas_fd_stream.c
    libpas/src/libpas/pas_free_granules.c
    libpas/src/libpas/pas_heap.c
    libpas/src/libpas/pas_heap_config.c
    libpas/src/libpas/pas_heap_config_kind.c
    libpas/src/libpas/pas_heap_config_utils.c
    libpas/src/libpas/pas_heap_for_config.c
    libpas/src/libpas/pas_heap_lock.c
    libpas/src/libpas/pas_heap_ref.c
    libpas/src/libpas/pas_heap_runtime_config.c
    libpas/src/libpas/pas_heap_summary.c
    libpas/src/libpas/pas_heap_table.c
    libpas/src/libpas/pas_immortal_heap.c
    libpas/src/libpas/pas_large_expendable_memory.c
    libpas/src/libpas/pas_large_free_heap_deferred_commit_log.c
    libpas/src/libpas/pas_large_free_heap_helpers.c
    libpas/src/libpas/pas_large_heap.c
    libpas/src/libpas/pas_large_heap_physical_page_sharing_cache.c
    libpas/src/libpas/pas_large_map.c
    libpas/src/libpas/pas_large_sharing_pool.c
    libpas/src/libpas/pas_large_utility_free_heap.c
    libpas/src/libpas/pas_lenient_compact_unsigned_ptr.c
    libpas/src/libpas/pas_local_allocator.c
    libpas/src/libpas/pas_local_allocator_scavenger_data.c
    libpas/src/libpas/pas_local_view_cache.c
    libpas/src/libpas/pas_lock.c
    libpas/src/libpas/pas_lock_free_read_ptr_ptr_hashtable.c
    libpas/src/libpas/pas_log.c
    libpas/src/libpas/pas_malloc_stack_logging.c
    libpas/src/libpas/pas_medium_megapage_cache.c
    libpas/src/libpas/pas_megapage_cache.c
    libpas/src/libpas/pas_monotonic_time.c
    libpas/src/libpas/pas_page_base.c
    libpas/src/libpas/pas_page_base_config.c
    libpas/src/libpas/pas_page_header_table.c
    libpas/src/libpas/pas_page_malloc.c
    libpas/src/libpas/pas_page_sharing_participant.c
    libpas/src/libpas/pas_page_sharing_pool.c
    libpas/src/libpas/pas_payload_reservation_page_list.c
    libpas/src/libpas/pas_physical_memory_transaction.c
    libpas/src/libpas/pas_primitive_heap_ref.c
    libpas/src/libpas/pas_probabilistic_guard_malloc_allocator.c
    libpas/src/libpas/pas_ptr_worklist.c
    libpas/src/libpas/pas_race_test_hooks.c
    libpas/src/libpas/pas_random.c
    libpas/src/libpas/pas_red_black_tree.c
    libpas/src/libpas/pas_redundant_local_allocator_node.c
    libpas/src/libpas/pas_report_crash.c
    libpas/src/libpas/pas_reserved_memory_provider.c
    libpas/src/libpas/pas_root.c
    libpas/src/libpas/pas_scavenger.c
    libpas/src/libpas/pas_segregated_directory.c
    libpas/src/libpas/pas_segregated_exclusive_view.c
    libpas/src/libpas/pas_segregated_heap.c
    libpas/src/libpas/pas_segregated_page.c
    libpas/src/libpas/pas_segregated_page_config.c
    libpas/src/libpas/pas_segregated_page_config_kind.c
    libpas/src/libpas/pas_segregated_page_config_kind_and_role.c
    libpas/src/libpas/pas_segregated_partial_view.c
    libpas/src/libpas/pas_segregated_shared_handle.c
    libpas/src/libpas/pas_segregated_shared_page_directory.c
    libpas/src/libpas/pas_segregated_shared_view.c
    libpas/src/libpas/pas_segregated_size_directory.c
    libpas/src/libpas/pas_segregated_view.c
    libpas/src/libpas/pas_shared_page_directory_by_size.c
    libpas/src/libpas/pas_simple_free_heap_helpers.c
    libpas/src/libpas/pas_simple_large_free_heap.c
    libpas/src/libpas/pas_simple_type.c
    libpas/src/libpas/pas_status_reporter.c
    libpas/src/libpas/pas_stream.c
    libpas/src/libpas/pas_string_stream.c
    libpas/src/libpas/pas_thread_suspend_lock.c
    libpas/src/libpas/pas_thread_local_cache.c
    libpas/src/libpas/pas_thread_local_cache_layout.c
    libpas/src/libpas/pas_thread_local_cache_layout_node.c
    libpas/src/libpas/pas_thread_local_cache_node.c
    libpas/src/libpas/pas_utility_heap.c
    libpas/src/libpas/pas_utility_heap_config.c
    libpas/src/libpas/pas_utils.c
    libpas/src/libpas/pas_versioned_field.c
    libpas/src/libpas/pas_virtual_range.c
    libpas/src/libpas/thingy_heap.c
    libpas/src/libpas/thingy_heap_config.c
)

set(bmalloc_PUBLIC_HEADERS
    bmalloc/Algorithm.h
    bmalloc/AllIsoHeaps.h
    bmalloc/AllIsoHeapsInlines.h
    bmalloc/AllocationCounts.h
    bmalloc/Allocator.h
    bmalloc/AvailableMemory.h
    bmalloc/BAssert.h
    bmalloc/BCompiler.h
    bmalloc/BExport.h
    bmalloc/BInline.h
    bmalloc/BMalloced.h
    bmalloc/BPlatform.h
    bmalloc/BSyscall.h
    bmalloc/BVMTags.h
    bmalloc/Bits.h
    bmalloc/BulkDecommit.h
    bmalloc/BumpAllocator.h
    bmalloc/BumpRange.h
    bmalloc/Cache.h
    bmalloc/Chunk.h
    bmalloc/CryptoRandom.h
    bmalloc/Deallocator.h
    bmalloc/DebugHeap.h
    bmalloc/DeferredDecommit.h
    bmalloc/DeferredDecommitInlines.h
    bmalloc/DeferredTrigger.h
    bmalloc/DeferredTriggerInlines.h
    bmalloc/EligibilityResult.h
    bmalloc/EligibilityResultInlines.h
    bmalloc/Environment.h
    bmalloc/FailureAction.h
    bmalloc/FixedVector.h
    bmalloc/FreeList.h
    bmalloc/FreeListInlines.h
    bmalloc/Gigacage.h
    bmalloc/GigacageConfig.h
    bmalloc/GigacageKind.h
    bmalloc/Heap.h
    bmalloc/HeapConstants.h
    bmalloc/HeapKind.h
    bmalloc/IsoAllocator.h
    bmalloc/IsoAllocatorInlines.h
    bmalloc/IsoConfig.h
    bmalloc/IsoDeallocator.h
    bmalloc/IsoDeallocatorInlines.h
    bmalloc/IsoDirectory.h
    bmalloc/IsoDirectoryInlines.h
    bmalloc/IsoDirectoryPage.h
    bmalloc/IsoDirectoryPageInlines.h
    bmalloc/IsoHeap.h
    bmalloc/IsoHeapImpl.h
    bmalloc/IsoHeapImplInlines.h
    bmalloc/IsoHeapInlines.h
    bmalloc/IsoMallocFallback.h
    bmalloc/IsoPage.h
    bmalloc/IsoPageInlines.h
    bmalloc/IsoPageTrigger.h
    bmalloc/IsoSharedConfig.h
    bmalloc/IsoSharedHeap.h
    bmalloc/IsoSharedHeapInlines.h
    bmalloc/IsoSharedPage.h
    bmalloc/IsoSharedPageInlines.h
    bmalloc/IsoTLS.h
    bmalloc/IsoTLSAllocatorEntry.h
    bmalloc/IsoTLSAllocatorEntryInlines.h
    bmalloc/IsoTLSDeallocatorEntry.h
    bmalloc/IsoTLSDeallocatorEntryInlines.h
    bmalloc/IsoTLSEntry.h
    bmalloc/IsoTLSEntryInlines.h
    bmalloc/IsoTLSInlines.h
    bmalloc/IsoTLSLayout.h
    bmalloc/LargeMap.h
    bmalloc/LargeRange.h
    bmalloc/LineMetadata.h
    bmalloc/List.h
    bmalloc/Logging.h
    bmalloc/Map.h
    bmalloc/Mutex.h
    bmalloc/Object.h
    bmalloc/ObjectType.h
    bmalloc/ObjectTypeTable.h
    bmalloc/Packed.h
    bmalloc/PerHeapKind.h
    bmalloc/PerProcess.h
    bmalloc/PerThread.h
    bmalloc/PhysicalPageMap.h
    bmalloc/ProcessCheck.h
    bmalloc/Range.h
    bmalloc/Scavenger.h
    bmalloc/ScopeExit.h
    bmalloc/Sizes.h
    bmalloc/SmallLine.h
    bmalloc/SmallPage.h
    bmalloc/StaticPerProcess.h
    bmalloc/StdLibExtras.h
    bmalloc/VMAllocate.h
    bmalloc/Vector.h
    bmalloc/Zone.h
    bmalloc/bmalloc.h
    bmalloc/valgrind.h

    libpas/src/libpas/bmalloc_heap_config.h
    libpas/src/libpas/bmalloc_heap.h
    libpas/src/libpas/bmalloc_heap_inlines.h
    libpas/src/libpas/bmalloc_heap_innards.h
    libpas/src/libpas/bmalloc_heap_ref.h
    libpas/src/libpas/bmalloc_type.h
    libpas/src/libpas/hotbit_heap_config.h
    libpas/src/libpas/hotbit_heap.h
    libpas/src/libpas/hotbit_heap_inlines.h
    libpas/src/libpas/hotbit_heap_innards.h
    libpas/src/libpas/iso_heap_config.h
    libpas/src/libpas/iso_heap.h
    libpas/src/libpas/iso_heap_inlines.h
    libpas/src/libpas/iso_heap_innards.h
    libpas/src/libpas/iso_heap_ref.h
    libpas/src/libpas/iso_test_heap_config.h
    libpas/src/libpas/iso_test_heap.h
    libpas/src/libpas/jit_heap_config.h
    libpas/src/libpas/jit_heap_config_root_data.h
    libpas/src/libpas/jit_heap.h
    libpas/src/libpas/minalign32_heap_config.h
    libpas/src/libpas/minalign32_heap.h
    libpas/src/libpas/pagesize64k_heap_config.h
    libpas/src/libpas/pagesize64k_heap.h
    libpas/src/libpas/pas_aligned_allocation_result.h
    libpas/src/libpas/pas_aligned_allocator.h
    libpas/src/libpas/pas_alignment.h
    libpas/src/libpas/pas_all_heap_configs.h
    libpas/src/libpas/pas_all_heaps.h
    libpas/src/libpas/pas_allocation_callbacks.h

=== Source/WTF/wtf/CMakeLists.txt ===
set(WTF_PUBLIC_HEADERS
    ASCIICType.h
    AccessibleAddress.h
    AggregateLogger.h
    Algorithms.h
    AnsiColors.h
    ApproximateTime.h
    ArgumentCoder.h
    Assertions.h
    Atomics.h
    AutodrainedPool.h
    AutomaticThread.h
    BackwardsGraph.h
    Bag.h
    BagToHashMap.h
    BitSet.h
    BitVector.h
    BlockObjCExceptions.h
    BlockPtr.h
    BloomFilter.h
    BooleanLattice.h
    Box.h
    BoxPtr.h
    Brigand.h
    BubbleSort.h
    BumpPointerAllocator.h
    ButterflyArray.h
    ByteOrder.h
    CPUTime.h
    CagedPtr.h
    CagedUniquePtr.h
    CallbackAggregator.h
    CancellableTask.h
    CheckedArithmetic.h
    CheckedBoolean.h
    CheckedPtr.h
    CheckedRef.h
    ClockType.h
    CodePtr.h
    CommaPrinter.h
    CompactPointerTuple.h
    CompactPtr.h
    CompactRefPtr.h
    CompactRefPtrTuple.h
    CompactUniquePtrTuple.h
    CompilationThread.h
    Compiler.h
    CompletionHandler.h
    ConcurrentBuffer.h
    ConcurrentPtrHashSet.h
    ConcurrentVector.h
    Condition.h
    CountingLock.h
    CrossThreadCopier.h
    CrossThreadQueue.h
    CrossThreadTask.h
    CrossThreadTaskHandler.h
    CryptographicUtilities.h
    CryptographicallyRandomNumber.h
    DataLog.h
    DataMutex.h
    DataRef.h
    DateMath.h
    DebugHeap.h
    DebugUtilities.h
    DeferrableRefCounted.h
    Deque.h
    DisallowCType.h
    Dominators.h
    DoublyLinkedList.h
    EmbeddedFixedVector.h
    EnumClassOperatorOverloads.h
    EnumTraits.h
    EnumeratedArray.h
    Expected.h
    ExperimentalFeatureNames.h
    ExportMacros.h
    FailureAction.h
    FastBitVector.h
    FastFloat.h
    FastMalloc.h
    FastTLS.h
    FilePrintStream.h
    FileSystem.h
    FixedBitVector.h
    FixedVector.h
    FixedWidthDouble.h
    FlipBytes.h
    ForbidHeapAllocation.h
    Forward.h
    Function.h
    FunctionDispatcher.h
    FunctionPtr.h
    FunctionTraits.h
    GenericHashKey.h
    GenericTimeMixin.h
    GetPtr.h
    Gigacage.h
    GlobalVersion.h
    GraphNodeWorklist.h
    GregorianDateTime.h
    HashCountedSet.h
    HashFunctions.h
    HashIterators.h
    HashMap.h
    HashMethod.h
    HashSet.h
    HashTable.h
    HashTraits.h
    Hasher.h
    HexNumber.h
    Identified.h
    Indenter.h
    IndexKeyType.h
    IndexMap.h
    IndexSet.h
    IndexSparseSet.h
    IndexedContainerIterator.h
    InlineASM.h
    Insertion.h
    InstanceCounted.h
    Int128.h
    InterferenceGraph.h
    IsoMalloc.h
    IsoMallocInlines.h
    IterationStatus.h
    IteratorAdaptors.h
    IteratorRange.h
    JSONValues.h
    JSValueMalloc.h
    KeyValuePair.h
    LEBDecoder.h
    Language.h
    LazyRef.h
    LazyUniqueRef.h
    LikelyDenseUnsignedIntegerSet.h
    ListDump.h
    ListHashSet.h
    Liveness.h
    Lock.h
    LockAlgorithm.h
    LockAlgorithmInlines.h
    LockedPrintStream.h
    Locker.h
    LocklessBag.h
    LogChannels.h
    LogInitialization.h
    Logger.h
    LoggerHelper.h
    Logging.h
    LoggingAccumulator.h
    LoggingHashID.h
    LoggingHashMap.h
    LoggingHashSet.h
    LoggingHashTraits.h
    MachSendRight.h
    MainThread.h
    MainThreadData.h
    MallocPtr.h
    Markable.h
    MathExtras.h
    MediaTime.h
    MemoryFootprint.h
    MemoryPressureHandler.h
    MessageQueue.h
    MetaAllocator.h
    MetaAllocatorHandle.h
    MonotonicTime.h
    NakedPtr.h
    NakedRef.h
    NativePromise.h
    NaturalLoops.h
    NeverDestroyed.h
    NoLock.h
    NoTailCalls.h
    Noncopyable.h
    Nonmovable.h
    NotFound.h
    NumberOfCores.h
    OSAllocator.h
    OSObjectPtr.h
    OSRandomSource.h
    ObjCRuntimeExtras.h
    ObjectIdentifier.h
    Observer.h
    OptionSet.h
    OptionSetHash.h
    OrderMaker.h
    Packed.h
    PackedRef.h
    PackedRefPtr.h
    PageAllocation.h
    PageBlock.h
    PageReservation.h
    ParallelHelperPool.h
    ParallelJobs.h
    ParallelJobsGeneric.h
    ParallelJobsLibdispatch.h
    ParallelJobsOpenMP.h
    ParallelVectorIterator.h
    ParkingLot.h
    Platform.h
    PlatformCallingConventions.h
    PlatformCPU.h
    PlatformEnable.h
    PlatformEnableCocoa.h
    PlatformEnableGlib.h
    PlatformEnablePlayStation.h
    PlatformEnableWinCairo.h
    PlatformHave.h
    PlatformLegacy.h
    PlatformOS.h
    PlatformRegisters.h
    PlatformUse.h
    PointerComparison.h
    PointerPreparations.h
    PrintStream.h
    PriorityQueue.h
    ProcessID.h
    ProcessPrivilege.h
    PtrTag.h
    RAMSize.h
    RandomDevice.h
    Range.h
    RangeSet.h
    RawHex.h
    RawPointer.h
    RawPtrTraits.h
    RawValueTraits.h
    ReadWriteLock.h
    RecursableLambda.h
    RecursiveLockAdapter.h
    RedBlackTree.h
    Ref.h
    RefCounted.h
    RefCountedFixedVector.h
    RefCountedLeakCounter.h
    RefCounter.h
    RefPtr.h
    RefVector.h
    ReferenceWrapperVector.h
    ResourceUsage.h
    RetainPtr.h
    RobinHoodHashMap.h
    RobinHoodHashSet.h
    RobinHoodHashTable.h
    RunLoop.h
    SHA1.h
    SafeStrerror.h
    SaturatedArithmetic.h
    SchedulePair.h
    Scope.h
    ScopedLambda.h
    Seconds.h
    SegmentedVector.h
    SentinelLinkedList.h
    SetForScope.h
    SharedTask.h
    SignedPtr.h
    SimpleStats.h
    SingleRootGraph.h
    SingleThreadIntegralWrapper.h
    SinglyLinkedList.h
    SinglyLinkedListWithTail.h
    SixCharacterHash.h
    SmallSet.h
    SoftLinking.h
    SortedArrayMap.h
    SpanningTree.h
    Spectrum.h
    StackBounds.h
    StackCheck.h
    StackPointer.h
    StackShot.h
    StackShotProfiler.h
    StackStats.h
    StackTrace.h
    StdFilesystem.h
    StdIntExtras.h
    StdLibExtras.h
    StdList.h
    StdMap.h
    StdSet.h
    StdUnorderedMap.h
    StdUnorderedSet.h
    Stopwatch.h
    StreamBuffer.h
    StringExtras.h
    StringHashDumpContext.h
    StringPrintStream.h
    SuspendableWorkQueue.h
    SynchronizedFixedQueue.h
    SystemFree.h
    SystemMalloc.h
    SystemTracing.h
    TZoneMalloc.h
    TZoneMallocInlines.h
    TaggedArrayStoragePtr.h
    ThreadAssertions.h
    ThreadGroup.h
    ThreadMessage.h
    ThreadSafetyAnalysis.h
    ThreadSafeRefCounted.h
    ThreadSafeWeakHashSet.h
    ThreadSafeWeakPtr.h
    ThreadSanitizerSupport.h
    ThreadSpecific.h
    Threading.h
    ThreadingPrimitives.h
    TimeWithDynamicClockType.h
    TimingScope.h
    TinyLRUCache.h
    TinyPtrSet.h
    TrailingArray.h
    TranslatedProcess.h
    TriState.h
    TypeCasts.h
    TypeTraits.h
    URL.h
    URLHelpers.h
    URLHash.h
    URLParser.h
    UUID.h
    UnalignedAccess.h
    Unexpected.h
    UniStdExtras.h
    UnionFind.h
    UniqueArray.h
    UniqueRef.h
    UniqueRefVector.h
    VMTags.h
    ValueCheck.h
    Vector.h
    VectorHash.h
    VectorTraits.h
    WTFConfig.h
    WTFProcess.h
    WTFSemaphore.h
    WallTime.h
    WeakHashCountedSet.h
    WeakHashMap.h
    WeakHashSet.h
    WeakListHashSet.h
    WeakPtr.h
    WeakRandom.h
    WeakRandomNumber.h
    WeakRef.h
    WindowsExtras.h
    WordLock.h
    WorkQueue.h
    WorkerPool.h
    dtoa.h

    dragonbox/dragonbox.h
    dragonbox/dragonbox_to_chars.h
    dragonbox/ieee754_format.h

    dragonbox/detail/bits.h
    dragonbox/detail/cache_holder.h
    dragonbox/detail/decimal_fp.h
    dragonbox/detail/div.h
    dragonbox/detail/log.h
    dragonbox/detail/policy.h
    dragonbox/detail/policy_holder.h
    dragonbox/detail/util.h
    dragonbox/detail/wuint.h

    dtoa/bignum-dtoa.h
    dtoa/bignum.h
    dtoa/cached-powers.h
    dtoa/diy-fp.h
    dtoa/double-conversion.h
    dtoa/fast-dtoa.h
    dtoa/fixed-dtoa.h
    dtoa/ieee.h
    dtoa/strtod.h
    dtoa/utils.h

    fast_float/ascii_number.h
    fast_float/bigint.h
    fast_float/decimal_to_binary.h
    fast_float/digit_comparison.h
    fast_float/fast_float.h
    fast_float/fast_table.h
    fast_float/float_common.h
    fast_float/parse_number.h
    fast_float/simple_decimal_conversion.h

    persistence/PersistentCoders.h
    persistence/PersistentDecoder.h
    persistence/PersistentEncoder.h

    text/ASCIIFastPath.h
    text/ASCIILiteral.h
    text/AdaptiveStringSearcher.h
    text/AtomString.h
    text/AtomStringHash.h
    text/AtomStringImpl.h
    text/AtomStringTable.h
    text/Base64.h
    text/CString.h
    text/CodePointIterator.h
    text/ConversionMode.h
    text/EscapedFormsForJSON.h
    text/ExternalStringImpl.h
    text/FastCharacterComparison.h
    text/IntegerToStringConversion.h
    text/LChar.h
    text/LineEnding.h
    text/NullTextBreakIterator.h
    text/OrdinalNumber.h
    text/StringBuffer.h
    text/StringBuilder.h
    text/StringBuilderInternals.h
    text/StringCommon.h
    text/StringConcatenate.h
    text/StringConcatenateNumbers.h
    text/StringHash.h
    text/StringHasher.h
    text/StringHasherInlines.h
    text/SuperFastHash.h
    text/WYHash.h
    text/StringImpl.h
    text/StringOperators.h
    text/StringParsingBuffer.h
    text/StringSearch.h
    text/StringToIntegerConversion.h
    text/StringView.h
    text/SymbolImpl.h
    text/SymbolRegistry.h
    text/TextBreakIterator.h
    text/TextBreakIteratorInternalICU.h
    text/TextPosition.h
    text/TextStream.h
    text/UTF8ConversionError.h
    text/UniquedStringImpl.h
    text/WTFString.h

    text/icu/TextBreakIteratorICU.h
    text/icu/UTextProvider.h
    text/icu/UTextProviderLatin1.h
    text/icu/UTextProviderUTF16.h

    threads/BinarySemaphore.h
    threads/Signals.h

    unicode/CharacterNames.h
    unicode/Collator.h
    unicode/UTF8Conversion.h

    unicode/icu/ICUHelpers.h
)

set(WTF_SOURCES
    ASCIICType.cpp
    ApproximateTime.cpp
    Assertions.cpp
    AutomaticThread.cpp
    BitVector.cpp
    BloomFilter.cpp
    CPUTime.cpp
    ClockType.cpp
    CodePtr.cpp
    CompilationThread.cpp
    ConcurrentBuffer.cpp
    ConcurrentPtrHashSet.cpp
    CountingLock.cpp
    CrossThreadCopier.cpp
    CrossThreadTaskHandler.cpp
    CryptographicUtilities.cpp
    CryptographicallyRandomNumber.cpp
    CurrentTime.cpp
    DataLog.cpp
    DateMath.cpp
    DebugHeap.cpp
    EmbeddedFixedVector.cpp
    FastBitVector.cpp
    FastFloat.cpp
    FastMalloc.cpp
    FilePrintStream.cpp
    FileSystem.cpp
    FunctionDispatcher.cpp
    Gigacage.cpp
    GlobalVersion.cpp
    GregorianDateTime.cpp
    HashTable.cpp
    HexNumber.cpp
    Int128.cpp
    JSONValues.cpp
    JSValueMalloc.cpp
    Language.cpp
    LikelyDenseUnsignedIntegerSet.cpp
    Lock.cpp
    LockedPrintStream.cpp
    LogChannels.cpp
    LogInitialization.cpp
    Logger.cpp
    Logging.cpp
    MainThread.cpp
    MediaTime.cpp
    MemoryPressureHandler.cpp
    MetaAllocator.cpp
    MonotonicTime.cpp
    NativePromise.cpp
    NumberOfCores.cpp
    OSRandomSource.cpp
    ObjectIdentifier.cpp
    PageBlock.cpp
    ParallelHelperPool.cpp
    ParallelJobsGeneric.cpp
    ParkingLot.cpp
    PrintStream.cpp
    ProcessPrivilege.cpp
    RAMSize.cpp
    RandomDevice.cpp
    ReadWriteLock.cpp
    RefCounted.cpp
    RefCountedLeakCounter.cpp
    RunLoop.cpp
    SHA1.cpp
    SafeStrerror.cpp
    Seconds.cpp
    SegmentedVector.cpp
    SixCharacterHash.cpp
    SmallSet.cpp
    StackBounds.cpp
    StackCheck.cpp
    StackPointer.cpp
    StackStats.cpp
    StackTrace.cpp
    StringPrintStream.cpp
    SuspendableWorkQueue.cpp
    ThreadGroup.cpp
    ThreadMessage.cpp
    Threading.cpp
    TimeWithDynamicClockType.cpp
    TimingScope.cpp
    URL.cpp
    URLHelpers.cpp
    URLParser.cpp
    UUID.cpp
    UniqueArray.cpp
    Vector.cpp
    WTFAssertions.cpp
    WTFConfig.cpp
    WTFProcess.cpp
    WallTime.cpp
    WeakPtr.cpp
    WeakRandomNumber.cpp
    WordLock.cpp
    WorkQueue.cpp
    WorkerPool.cpp
    dtoa.cpp

    dragonbox/dragonbox_to_chars.cpp

    dtoa/bignum-dtoa.cc
    dtoa/bignum.cc
    dtoa/cached-powers.cc
    dtoa/diy-fp.cc
    dtoa/double-conversion.cc
    dtoa/fast-dtoa.cc
    dtoa/fixed-dtoa.cc
    dtoa/strtod.cc

    persistence/PersistentCoders.cpp
    persistence/PersistentDecoder.cpp
    persistence/PersistentEncoder.cpp

    text/ASCIILiteral.cpp
    text/AtomString.cpp
    text/AtomStringImpl.cpp
    text/AtomStringTable.cpp
    text/Base64.cpp
    text/CString.cpp
    text/ExternalStringImpl.cpp

=== Source/WebKit/WPEPlatform/CMakeLists.txt ===
set_property(DIRECTORY . PROPERTY FOLDER "WPEPlatform")

file(MAKE_DIRECTORY ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe)

configure_file(wpe-platform.pc.in ${CMAKE_BINARY_DIR}/wpe-platform-${WPE_API_VERSION}.pc @ONLY)
configure_file(wpe-platform-uninstalled.pc.in ${CMAKE_BINARY_DIR}/wpe-platform-${WPE_API_VERSION}-uninstalled.pc @ONLY)
configure_file(wpe/WPEConfig.h.in ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEConfig.h)
configure_file(wpe/WPEVersion.h.in ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEVersion.h)

set(WPEPlatform_SOURCES
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEEvent.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEBuffer.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEBufferDMABuf.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEBufferDMABufFormat.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEBufferSHM.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPECursorTheme.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEDisplay.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEEGLError.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEExtensions.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEKeyUnicode.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEKeymap.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEKeymapXKB.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEMonitor.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEVersion.cpp
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEView.cpp
    ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEEnumTypes.cpp
)

set(WPEPlatform_INSTALLED_HEADERS
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEEvent.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEBuffer.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEBufferDMABuf.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEBufferDMABufFormat.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEBufferSHM.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEDefines.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEDisplay.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEEGLError.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEKeyUnicode.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEKeymap.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEKeymapXKB.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEKeysyms.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEMonitor.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/WPEView.h
    ${WEBKIT_DIR}/WPEPlatform/wpe/wpe-platform.h
    ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEConfig.h
    ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEEnumTypes.h
    ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEVersion.h
)

set(WPEPlatform_ENUM_GENERATION_HEADERS ${WPEPlatform_INSTALLED_HEADERS})
list(REMOVE_ITEM WPEPlatform_ENUM_GENERATION_HEADERS ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEEnumTypes.h)
add_custom_command(
    OUTPUT ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEEnumTypes.h
    DEPENDS ${WPEPlatform_ENUM_GENERATION_HEADERS}
    COMMAND glib-mkenums --template ${WEBKIT_DIR}/WPEPlatform/wpe/WPEEnumTypes.h.in ${WPEPlatform_ENUM_GENERATION_HEADERS} | sed s/w_pe/wpe/ | sed s/WPE_TYPE_PE/WPE_TYPE/ | sed s/WPE_TYPEEGL/WPE_TYPE_EGL/ | sed s/wpeegl/wpe_egl/ > ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEEnumTypes.h
    VERBATIM
)
add_custom_command(
    OUTPUT ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEEnumTypes.cpp
    DEPENDS ${WPEPlatform_ENUM_GENERATION_HEADERS}
    COMMAND glib-mkenums --template ${WEBKIT_DIR}/WPEPlatform/wpe/WPEEnumTypes.cpp.in ${WPEPlatform_ENUM_GENERATION_HEADERS} | sed s/w_pe/wpe/ | sed s/WPE_TYPE_PE/WPE_TYPE/ | sed s/WPE_TYPEEGL/WPE_TYPE_GL/ | sed s/wpeegl/wpe_egl/ > ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEEnumTypes.cpp
    VERBATIM
)
add_custom_target(WPEPlatformGeneratedEnumTypesHeader
    DEPENDS ${WPEPlatform_DERIVED_SOURCES_DIR}/wpe/WPEEnumTypes.h
)

set(WPEPlatform_PRIVATE_INCLUDE_DIRECTORIES
    "${CMAKE_BINARY_DIR}"
    "${WPEPlatform_DERIVED_SOURCES_DIR}"
    "${WPEPlatform_DERIVED_SOURCES_DIR}/wpe"
    "${WEBKIT_DIR}/WPEPlatform"
    "${WEBKIT_DIR}/WPEPlatform/wpe"
    "${WTF_FRAMEWORK_HEADERS_DIR}"
)

set(WPEPlatform_SYSTEM_INCLUDE_DIRECTORIES
    ${GLIB_INCLUDE_DIRS}
)

set(WPEPlatform_LIBRARIES
    Epoxy::Epoxy
    WTF
    ${GLIB_GIO_LIBRARIES}
    ${GLIB_GOBJECT_LIBRARIES}
    ${GLIB_LIBRARIES}
    ${LIBXKBCOMMON_LIBRARIES}
)

if (USE_GBM)
    list(APPEND WPEPlatform_LIBRARIES GBM::GBM)
elseif (USE_LIBDRM)
    list(APPEND WPEPlatform_LIBRARIES LibDRM::LibDRM)
endif ()

if (NOT USE_SYSTEM_MALLOC)
   list(APPEND WPEPlatform_LIBRARIES bmalloc)
endif ()

if (ENABLE_WPE_PLATFORM_DRM)
    add_subdirectory(${WEBKIT_DIR}/WPEPlatform/wpe/drm)
    list(APPEND WPEPlatform_LIBRARIES WPEPlatformDRM)
endif ()

if (ENABLE_WPE_PLATFORM_HEADLESS)
    add_subdirectory(${WEBKIT_DIR}/WPEPlatform/wpe/headless)
    list(APPEND WPEPlatform_LIBRARIES WPEPlatformHeadless)
endif ()

if (ENABLE_WPE_PLATFORM_WAYLAND)
    add_subdirectory(${WEBKIT_DIR}/WPEPlatform/wpe/wayland)
    list(APPEND WPEPlatform_LIBRARIES WPEPlatformWayland)
endif ()

add_library(WPEPlatform-${WPE_API_VERSION} SHARED ${WPEPlatform_SOURCES})
set_target_properties(WPEPlatform-${WPE_API_VERSION} PROPERTIES VERSION ${WPE_PLATFORM_VERSION} SOVERSION ${WPE_PLATFORM_VERSION_MAJOR})
target_include_directories(WPEPlatform-${WPE_API_VERSION} PRIVATE ${WPEPlatform_PRIVATE_INCLUDE_DIRECTORIES})
target_include_directories(WPEPlatform-${WPE_API_VERSION} SYSTEM PRIVATE ${WPEPlatform_SYSTEM_INCLUDE_DIRECTORIES})
target_link_libraries(WPEPlatform-${WPE_API_VERSION} ${WPEPlatform_LIBRARIES})

GI_INTROSPECT(WPEPlatform ${WPE_API_VERSION} wpe/wpe-platform.h
    TARGET WPEPlatform-${WPE_API_VERSION}
    PACKAGE wpe-platform
    IDENTIFIER_PREFIX WPE
    SYMBOL_PREFIX wpe
    DEPENDENCIES Gio-2.0
    OPTIONS
        -I${WEBKIT_DIR}/WPEPlatform
        -I${WPEPlatform_DERIVED_SOURCES_DIR}
    SOURCES
        ${WPEPlatform_INSTALLED_HEADERS}
        ${WPEPlatform_SOURCES}
    NO_IMPLICIT_SOURCES
)

GI_DOCGEN(WPEPlatform docs/wpeplatform.toml.in)

if (ENABLE_WPE_PLATFORM_DRM)
    get_target_property(WPEPlatformDRM_SOURCES_FOR_INTROSPECTION WPEPlatformDRM SOURCES_FOR_INTROSPECTION)
    GI_INTROSPECT(WPEPlatformDRM ${WPE_API_VERSION} wpe/drm/wpe-drm.h
        TARGET WPEPlatform-${WPE_API_VERSION}
        PACKAGE wpe-platform-drm
        IDENTIFIER_PREFIX WPE
        SYMBOL_PREFIX wpe
        DEPENDENCIES WPEPlatform
        OPTIONS
            -I${WEBKIT_DIR}/WPEPlatform
            -I${WPEPlatform_DERIVED_SOURCES_DIR}
        SOURCES
            ${WPEPlatformDRM_SOURCES_FOR_INTROSPECTION}
        NO_IMPLICIT_SOURCES
    )

    GI_DOCGEN(WPEPlatformDRM docs/wpeplatform-drm.toml.in)
endif ()

if (ENABLE_WPE_PLATFORM_HEADLESS)
    get_target_property(WPEPlatformHeadless_SOURCES_FOR_INTROSPECTION WPEPlatformHeadless SOURCES_FOR_INTROSPECTION)
    GI_INTROSPECT(WPEPlatformHeadless ${WPE_API_VERSION} wpe/headless/wpe-headless.h
        TARGET WPEPlatform-${WPE_API_VERSION}
        PACKAGE wpe-platform-headless
        IDENTIFIER_PREFIX WPE
        SYMBOL_PREFIX wpe
        DEPENDENCIES WPEPlatform
        OPTIONS
            -I${WEBKIT_DIR}/WPEPlatform
            -I${WPEPlatform_DERIVED_SOURCES_DIR}
        SOURCES
            ${WPEPlatformHeadless_SOURCES_FOR_INTROSPECTION}
        NO_IMPLICIT_SOURCES
    )

    GI_DOCGEN(WPEPlatformHeadless docs/wpeplatform-headless.toml.in)
endif ()

if (ENABLE_WPE_PLATFORM_WAYLAND)
    get_target_property(WPEPlatformWayland_SOURCES_FOR_INTROSPECTION WPEPlatformWayland SOURCES_FOR_INTROSPECTION)
    GI_INTROSPECT(WPEPlatformWayland ${WPE_API_VERSION} wpe/wayland/wpe-wayland.h
        TARGET WPEPlatform-${WPE_API_VERSION}
        PACKAGE wpe-platform-wayland
        IDENTIFIER_PREFIX WPE
        SYMBOL_PREFIX wpe
        DEPENDENCIES WPEPlatform
        OPTIONS
            -I${WEBKIT_DIR}/WPEPlatform
            -I${WPEPlatform_DERIVED_SOURCES_DIR}
        SOURCES
            ${WPEPlatformWayland_SOURCES_FOR_INTROSPECTION}
        NO_IMPLICIT_SOURCES
    )

    GI_DOCGEN(WPEPlatformWayland docs/wpeplatform-wayland.toml.in)
endif ()

install(TARGETS WPEPlatform-${WPE_API_VERSION} LIBRARY DESTINATION "${LIB_INSTALL_DIR}")

install(FILES "${CMAKE_BINARY_DIR}/wpe-platform-${WPE_API_VERSION}.pc"
        DESTINATION "${LIB_INSTALL_DIR}/pkgconfig"
        COMPONENT "Development"
)

install(FILES ${WPEPlatform_INSTALLED_HEADERS}
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/wpe-webkit-${WPE_API_VERSION}/wpe-platform/wpe"
        COMPONENT "Development"
)

=== debian/changelog ===
webkit2gtk (2.44.2-1~deb11u1) bullseye-security; urgency=medium

  * Rebuild for bullseye-security.
  * gcc 10 segfaults when building webkit in amd64 (see #1008098) so use
    clang instead. Keep using gcc in other architectures because clang has
    problems in at least i386, arm64 and mipsel (see #1010329 and
    #1016811).
    - debian/rules: Tell CMake to use clang.
    - debian/control.in: Build depend on clang.
  * Build libsoup2 packages only.
    - debian/rules: Set ENABLE_SOUP3=NO, ENABLE_GTK4=NO and
      USE_PREBUILT_DOCS=YES.
    - debian/control.in: Remove build dependency on ccache.
  * debian/rules:
    - Disable USE_AVI, USE_GBM, USE_GSTREAMER_TRANSCODER and USE_JPEGXL
      due to missing or additional build dependencies.
    - Enable USE_OLD_DOC_PKG and USE_OLD_JSCBIN_PKG to keep using the old
      package names.
  * debian/control.in:
    - Remove build dependencies on libgstreamer-plugins-bad1.0-dev,
      libjxl-dev and libavif-dev.
    - Make the -dev packages depend on the gir packages.
    - Replace gobject-introspection-bin with gobject-introspection.
  * debian/patches/disable-dmabuf.patch:
    - Disable the DMABuf renderer in all cases in bullseye
      (see #1054101).

 -- Alberto Garcia <berto@igalia.com>  Tue, 21 May 2024 16:05:47 +0200

webkit2gtk (2.44.2-1) unstable; urgency=high

  * New upstream release.
  * debian/upstream/signing-key.asc:
    - Replace Carlos Garcia's DSA key with the new RSA one.

 -- Alberto Garcia <berto@igalia.com>  Thu, 16 May 2024 14:09:54 +0200

=== debian/control ===
# This file is autogenerated. DO NOT EDIT
Source: webkit2gtk
Priority: optional
Section: web
Maintainer: Debian WebKit Maintainers <pkg-webkit-maintainers@lists.alioth.debian.org>
Uploaders: Gustavo Noronha Silva <kov@debian.org>,
           Emilio Pozuelo Monfort <pochu@debian.org>,
           Alberto Garcia <berto@igalia.com>
X-Ubuntu-Use-Langpack: no
Build-Depends: debhelper-compat (= 13),
               bubblewrap [amd64 arm64 armel armhf i386 mips64el ppc64el riscv64 s390x hppa ppc64 x32],
               xdg-dbus-proxy [amd64 arm64 armel armhf i386 mips64el ppc64el riscv64 s390x hppa ppc64 x32],
               libseccomp-dev [amd64 arm64 armel armhf i386 mips64el ppc64el riscv64 s390x hppa ppc64 x32],
               clang [amd64],
               cmake (>= 3.16),
               libglib2.0-dev,
               libharfbuzz-dev,
               libcairo2-dev,
               libdrm-dev [linux-any],
               libfontconfig-dev,
               libfreetype-dev,
               libicu-dev,
               libgcrypt20-dev,
               libhyphen-dev,
               liblcms2-dev,
               libmanette-0.2-dev (>= 0.2.4) [linux-any],
               libxslt1-dev,
               libxml2-dev,
               libsoup2.4-dev,libgtk-3-dev,
               libsqlite3-dev,
               libsystemd-dev [linux-any],
               libgudev-1.0-dev [linux-any],
               libwoff-dev,
               gperf,
               bison,
               flex,
               ruby:native,
               unifdef,
               libjpeg-dev,
               libopenjp2-7-dev,
               libpng-dev,
               libtasn1-6-dev,
               libwebp-dev,
               libxt-dev,
               libgstreamer1.0-dev,
               libgstreamer-plugins-base1.0-dev,
               libenchant-2-dev,
               libsecret-1-dev,
               gobject-introspection,
               libgirepository1.0-dev,
               ninja-build,
               libegl-dev,
               libgl-dev,
               libgles-dev
Build-Depends-Indep: jdupes
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/webkit-team/webkit
Vcs-Git: https://salsa.debian.org/webkit-team/webkit.git
Homepage: https://webkitgtk.org/

Package: libjavascriptcoregtk-4.0-bin
Section: interpreters
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libjavascriptcoregtk-4.0-18 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Conflicts: ${jscbin:Conflicts}
Breaks: ${jscbin:Replaces}
Replaces: ${jscbin:Replaces}
Description: JavaScript engine library from WebKitGTK - command-line interpreter
 JavaScriptCore is the JavaScript engine used in WebKit. It consists
 of the following building blocks: lexer, parser, start-up interpreter
 (LLInt), baseline JIT, a low-latency optimizing JIT (DFG), and a
 high-throughput optimizing JIT (FTL).
 .
 This package provides jsc, a command-line JavaScript interpreter.

Package: libwebkit2gtk-4.0-doc
Build-Profiles: <!nodoc>
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Conflicts: ${wkdoc:Conflicts}
Breaks: ${wkdoc:Replaces}
Replaces: ${wkdoc:Replaces}
Suggests: devhelp
Description: Web content engine library for GTK - documentation
 WebKit is a web content engine, derived from KHTML and KJS from KDE, and
 used primarily in Apple's Safari browser.  It is made to be embedded in
 other applications, such as mail readers, or web browsers.
 .
 It is able to display content such as HTML, SVG, XML, and others. It also
 supports DOM, XMLHttpRequest, XSLT, CSS, JavaScript/ECMAScript and more.
 .
 WebKitGTK is a WebKit port designed to be used in GTK applications.
 .
 This package contains the documentation.

Package: webkit2gtk-driver
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libwebkit2gtk-4.0-37 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: WebKitGTK WebDriver support
 WebKit is a web content engine, derived from KHTML and KJS from KDE, and
 used primarily in Apple's Safari browser.  It is made to be embedded in
 other applications, such as mail readers, or web browsers.
 .
 It is able to display content such as HTML, SVG, XML, and others. It also
 supports DOM, XMLHttpRequest, XSLT, CSS, JavaScript/ECMAScript and more.
 .
 WebKitGTK is a WebKit port designed to be used in GTK applications.
 .
 This package provides the WebDriver service implementation for
 WebKitGTK.

Package: libjavascriptcoregtk-4.0-18
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: JavaScript engine library from WebKitGTK
 JavaScriptCore is the JavaScript engine used in WebKit. It consists
 of the following building blocks: lexer, parser, start-up interpreter
 (LLInt), baseline JIT, a low-latency optimizing JIT (DFG), and a
 high-throughput optimizing JIT (FTL).
 .
 This build comes from the GTK port of WebKit (API version 4.0).
 .
 This package contains the shared libraries.

Package: libjavascriptcoregtk-4.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libjavascriptcoregtk-4.0-18 (= ${binary:Version}),
         gir1.2-javascriptcoregtk-4.0 (= ${binary:Version}),
         libglib2.0-dev,
         ${gir:Depends},
         ${misc:Depends}
Provides: ${gir:Provides}
Description: JavaScript engine library from WebKitGTK - development files
 JavaScriptCore is the JavaScript engine used in WebKit. It consists
 of the following building blocks: lexer, parser, start-up interpreter
 (LLInt), baseline JIT, a low-latency optimizing JIT (DFG), and a
 high-throughput optimizing JIT (FTL).
 .
 This build comes from the GTK port of WebKit (API version 4.0).
 .
 This package contains the development files.

Package: gir1.2-javascriptcoregtk-4.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends: libjavascriptcoregtk-4.0-18 (= ${binary:Version}),
         ${gir:Depends},
         ${misc:Depends}
Provides: ${gir:Provides}
Description: JavaScript engine library from WebKitGTK - GObject introspection data
 JavaScriptCore is the JavaScript engine used in WebKit. It consists
 of the following building blocks: lexer, parser, start-up interpreter
 (LLInt), baseline JIT, a low-latency optimizing JIT (DFG), and a
 high-throughput optimizing JIT (FTL).
 .
 This build comes from the GTK port of WebKit (API version 4.0).
 .
 This package contains the introspection data, which can be used by
 packages using the GIRepository format to generate dynamic bindings.

Package: libwebkit2gtk-4.0-37
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libjavascriptcoregtk-4.0-18 (= ${binary:Version}),
         gstreamer1.0-plugins-base,
         gstreamer1.0-plugins-good,
         libgles2,
         ${bwrap:Depends},
         ${shlibs:Depends},
         ${gles:Depends},
         ${misc:Depends}
Recommends: gstreamer1.0-gl,
            libgl1-mesa-dri,
            ${bwrap:Recommends},
            ${gst:Recommends}
Suggests: ${gst:Suggests},
         gstreamer1.0-alsa
Description: Web content engine library for GTK
 WebKit is a web content engine, derived from KHTML and KJS from KDE, and
 used primarily in Apple's Safari browser.  It is made to be embedded in
 other applications, such as mail readers, or web browsers.
 .
 It is able to display content such as HTML, SVG, XML, and others. It also
 supports DOM, XMLHttpRequest, XSLT, CSS, JavaScript/ECMAScript and more.
 .
 WebKitGTK is a WebKit port designed to be used in GTK applications.
 This build provides version 4.0 of the API and uses libsoup v2 for
 the networking stack and the GTK 3 widget toolkit.
 .
 This package contains the shared libraries.

Package: libwebkit2gtk-4.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libwebkit2gtk-4.0-37 (= ${binary:Version}),
         gir1.2-webkit2-4.0 (= ${binary:Version}),
         libgtk-3-dev,
         libsoup2.4-dev,
         libjavascriptcoregtk-4.0-dev (= ${binary:Version}),
         ${gir:Depends},
         ${misc:Depends}
Provides: ${gir:Provides}
Description: Web content engine library for GTK - development files
 WebKit is a web content engine, derived from KHTML and KJS from KDE, and
 used primarily in Apple's Safari browser.  It is made to be embedded in
 other applications, such as mail readers, or web browsers.
 .
 It is able to display content such as HTML, SVG, XML, and others. It also
 supports DOM, XMLHttpRequest, XSLT, CSS, JavaScript/ECMAScript and more.
 .
 WebKitGTK is a WebKit port designed to be used in GTK applications.
 This build provides version 4.0 of the API and uses libsoup v2 for
 the networking stack and the GTK 3 widget toolkit.
 .
 This package contains the development files.

Package: gir1.2-webkit2-4.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends: libwebkit2gtk-4.0-37 (= ${binary:Version}),
         ${gir:Depends},
         ${misc:Depends}
Provides: ${gir:Provides}
Description: Web content engine library for GTK - GObject introspection data
 WebKit is a web content engine, derived from KHTML and KJS from KDE, and
 used primarily in Apple's Safari browser.  It is made to be embedded in
 other applications, such as mail readers, or web browsers.
 .
 It is able to display content such as HTML, SVG, XML, and others. It also
 supports DOM, XMLHttpRequest, XSLT, CSS, JavaScript/ECMAScript and more.
 .
 WebKitGTK is a WebKit port designed to be used in GTK applications.
 This build provides version 4.0 of the API and uses libsoup v2 for
 the networking stack and the GTK 3 widget toolkit.
 .
 This package contains introspection data, which can be used by
 packages using the GIRepository format to generate dynamic bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

export CCACHE_NOHASHDIR=1
export CCACHE_DIR=$(CURDIR)/ccache

# soup2 build -> 4.0 API packages
# soup3 build -> 4.1 API packages
# gtk4 build  -> 6.0 API packages
ENABLE_SOUP2=YES
ENABLE_SOUP3=NO
ENABLE_GTK4=NO
# Set to YES to use the docs from the tarball instead of generating them.
# Use only if gi-docgen is not available.
USE_PREBUILT_DOCS=YES
# Set to YES to build libwebkit2gtk-4.0-doc instead of libwebkitgtk-doc
USE_OLD_DOC_PKG=YES

# Set to YES to build libjavascriptcoregtk-4.0-bin instead of libjavascriptcoregtk-bin
USE_OLD_JSCBIN_PKG=YES

EXTRA_DH_ARGUMENTS =
EXTRA_CMAKE_ARGUMENTS = -DPORT=GTK \
	   -DCMAKE_INSTALL_LIBEXECDIR=lib/$(DEB_HOST_MULTIARCH) \
	   -DCMAKE_C_FLAGS_RELEASE="" \
	   -DCMAKE_C_FLAGS_DEBUG="" \
	   -DCMAKE_CXX_FLAGS_RELEASE="" \
	   -DCMAKE_CXX_FLAGS_DEBUG="" \
	   -DCMAKE_BUILD_WITH_INSTALL_RPATH=ON \
	   -DUSE_LIBBACKTRACE=OFF \
	   -DUSE_AVIF=OFF \
	   -DUSE_GBM=OFF \
	   -DUSE_GSTREAMER_TRANSCODER=OFF \
	   -DUSE_JPEGXL=OFF \
	   -DENABLE_MINIBROWSER=ON
EXTRA_BUILD_ARGUMENTS =
DH_GENCONTROL_ARGS =

# gcc 10 segfaults when building webkit in amd64 (#1008098) so use clang
# However in i386, mipsel and arm64 clang is the buggy one (#1010329, #1016811)
ifneq (,$(filter $(DEB_HOST_ARCH),amd64))
	EXTRA_CMAKE_ARGUMENTS += \
	   -DCMAKE_C_COMPILER=clang \
	   -DCMAKE_CXX_COMPILER=clang++
endif

# Sacrifice speed in order to make it more likely resource limits
# won't be hit.
ifeq ($(DEB_BUILD_ARCH_BITS),32)
	EXTRA_CMAKE_ARGUMENTS += -DFORCE_32BIT=ON
	LDFLAGS += -Wl,--no-keep-memory
endif

# The debug packages produced by webkit are huge and cause problems in
# most buildds. Use -g1 in all architectures to make them smaller.
CFLAGS := $(CFLAGS:-g=-g1)
CXXFLAGS := $(CXXFLAGS:-g=-g1)

# Don't build with -gsplit-dwarf (see #1016936)
EXTRA_CMAKE_ARGUMENTS += -DDEBUG_FISSION=OFF

# Use the CLoop Javascript interpreter and disable the JIT. This is
# slow but it is the most compatible solution for old (non-SSE2) CPUs.
ifneq (,$(filter $(DEB_HOST_ARCH),i386))
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_JIT=OFF -DENABLE_C_LOOP=ON
endif

# These are not available in the Hurd (#1033999)
ifneq (,$(filter $(DEB_HOST_ARCH),hurd-i386))
	EXTRA_CMAKE_ARGUMENTS += -DUSE_GBM=OFF -DUSE_LIBDRM=OFF
endif

# Systemd/elogind and libmanette are Linux-only
ifneq ($(DEB_HOST_ARCH_OS),linux)
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_JOURNALD_LOG=OFF -DENABLE_GAMEPAD=OFF
endif

# See https://bugs.webkit.org/show_bug.cgi?id=197192
ifneq (,$(filter $(DEB_HOST_ARCH),arm64))
	EXTRA_CMAKE_ARGUMENTS += -DWTF_CPU_ARM64_CORTEXA53=OFF
endif

# See: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=93876
# and: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=93877
ifneq (,$(filter $(DEB_HOST_ARCH),sh3 sh4))
	CFLAGS := $(CFLAGS:-g1=-g0)
	CFLAGS := $(CFLAGS:-O2=-O1)
	CXXFLAGS := $(CXXFLAGS:-g1=-g0)
	CXXFLAGS := $(CXXFLAGS:-O2=-O1)
	CPPFLAGS += --param ggc-min-expand=10
endif

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	EXTRA_CMAKE_ARGUMENTS += -DUSE_SYSTEM_MALLOC=ON
	CPPFLAGS += -DRELEASE_WITHOUT_OPTIMIZATIONS
endif

ifeq (,$(filter %-doc,$(shell dh_listpackages)))
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_DOCUMENTATION=OFF
	USE_PREBUILT_DOCS=NO
else ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_DOCUMENTATION=OFF
	USE_PREBUILT_DOCS=NO
else ifeq ($(USE_PREBUILT_DOCS),YES)
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_DOCUMENTATION=OFF
else
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_DOCUMENTATION=ON
endif

ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
	EXTRA_CMAKE_ARGUMENTS += -DCMAKE_BUILD_TYPE=Debug
else
	EXTRA_CMAKE_ARGUMENTS += -DCMAKE_BUILD_TYPE=Release
	CPPFLAGS += -DNDEBUG -DG_DISABLE_CAST_CHECKS
endif

# Don't recommend xdg portals on Ubuntu i386 where it doesn't exist
ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_BUBBLEWRAP_SANDBOX=ON
	DH_GENCONTROL_ARGS += -Vbwrap:Depends="bubblewrap (>= 0.3.1), xdg-dbus-proxy"
# Disable the bubblewrap sandbox if libseccomp-dev is not available
else ifeq ($(shell pkg-config --exists libseccomp && echo yes),yes)
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_BUBBLEWRAP_SANDBOX=ON
	DH_GENCONTROL_ARGS += -Vbwrap:Depends="bubblewrap (>= 0.3.1), xdg-dbus-proxy"
	DH_GENCONTROL_ARGS += -Vbwrap:Recommends="xdg-desktop-portal-gtk"
else
	EXTRA_CMAKE_ARGUMENTS += -DENABLE_BUBBLEWRAP_SANDBOX=OFF
endif

# Lower max parallel jobs on some builders
ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes),yes)
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64))
	EXTRA_BUILD_ARGUMENTS += --max-parallel=2
endif
endif

# set the distributor agent for Ubuntu
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	EXTRA_CMAKE_ARGUMENTS += -DUSER_AGENT_BRANDING="Ubuntu"
endif

# libavif & gst-plugins-bad1.0 are not in Ubuntu main
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	EXTRA_CMAKE_ARGUMENTS += -DUSE_AVIF=OFF -DUSE_GSTREAMER_TRANSCODER=OFF
endif

# jpegxl is not in Ubuntu main
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	EXTRA_CMAKE_ARGUMENTS += -DUSE_JPEGXL=OFF
endif

# gstreamer1.0-libav and gstreamer1.0-plugins-bad are not in Ubuntu "main"
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	DH_GENCONTROL_ARGS += -Vgst:Suggests="gstreamer1.0-libav, gstreamer1.0-plugins-bad"
else
	DH_GENCONTROL_ARGS += -Vgst:Recommends="gstreamer1.0-libav, gstreamer1.0-plugins-bad"
endif

# This is loaded at runtime using libepoxy so add an explicit dependency (#1033230)
ifneq (,$(filter $(DEB_HOST_ARCH),arm64 armel armhf))
	DH_GENCONTROL_ARGS += -Vgles:Depends="libgles2"
endif

ifeq ($(USE_OLD_DOC_PKG),YES)
	LIBWEBKITGTKDOC_PKG=libwebkit2gtk-4.0-doc
	DH_GENCONTROL_ARGS += -Vwkdoc:Conflicts="libwebkitgtk-doc"
else
	LIBWEBKITGTKDOC_PKG=libwebkitgtk-doc
	DH_GENCONTROL_ARGS += -Vwkdoc:Replaces="libwebkit2gtk-4.0-doc (<< 2.43.4-2~)"
endif

ifeq ($(USE_OLD_JSCBIN_PKG),YES)
	LIBJSCBIN_PKG=libjavascriptcoregtk-4.0-bin
	LIBJSCBIN_DEP_PKG=libjavascriptcoregtk-4.0-18
	JSCBIN_BUILD=webkit2gtk-4.0
	DH_GENCONTROL_ARGS += -Vjscbin:Conflicts="libjavascriptcoregtk-bin"
else
	LIBJSCBIN_PKG=libjavascriptcoregtk-bin
	LIBJSCBIN_DEP_PKG=libjavascriptcoregtk-4.1-0
	JSCBIN_BUILD=webkit2gtk-4.1
	DH_GENCONTROL_ARGS += -Vjscbin:Replaces="libjavascriptcoregtk-4.0-bin (<< 2.43.4-2~)"
endif

# Disable commands and binary packages of the builds that we don't want
ifneq ($(ENABLE_SOUP2),YES)
	SOUP2_BUILD = @:
ifeq ($(USE_OLD_JSCBIN_PKG),YES)
	EXTRA_DH_ARGUMENTS += -Nlibjavascriptcoregtk-4.0-bin
endif
else
	SOUP2_BUILD_DEP=libsoup2.4-dev,
	GTK3_BUILD_DEP=libgtk-3-dev,
endif
ifneq ($(ENABLE_SOUP3),YES)
	SOUP3_BUILD = @:
else
	SOUP3_BUILD_DEP=libsoup-3.0-dev,
	GTK3_BUILD_DEP=libgtk-3-dev,
endif
ifneq ($(ENABLE_GTK4),YES)
	GTK4_BUILD = @:
ifeq ($(USE_PREBUILT_DOCS),NO)
	EXTRA_DH_ARGUMENTS += -N$(LIBWEBKITGTKDOC_PKG)
endif
else
	SOUP3_BUILD_DEP=libsoup-3.0-dev,
	GTK4_BUILD_DEP=libgtk-4-dev,
endif

# Decide what version of the WebKit WebDriver to build
ENABLE_WEBDRIVER_SOUP2 = -DENABLE_WEBDRIVER=OFF
ENABLE_WEBDRIVER_SOUP3 = -DENABLE_WEBDRIVER=OFF
ENABLE_WEBDRIVER_GTK4  = -DENABLE_WEBDRIVER=OFF
ifeq ($(ENABLE_SOUP3),YES)
	ENABLE_WEBDRIVER_SOUP3 = -DENABLE_WEBDRIVER=ON
	WEBDRIVER_DEP_PKG = libwebkit2gtk-4.1-0
else ifeq ($(ENABLE_SOUP2),YES)
	ENABLE_WEBDRIVER_SOUP2 = -DENABLE_WEBDRIVER=ON
	WEBDRIVER_DEP_PKG = libwebkit2gtk-4.0-37
else
	ENABLE_WEBDRIVER_GTK4 = -DENABLE_WEBDRIVER=ON
	WEBDRIVER_DEP_PKG = libwebkitgtk-6.0-4
endif

# The debhelper files for the soup2, soup3 and gtk4 builds are identical
# (apart from the API version) so we generate the last two from the first.
WEBKIT_DH_FILES = \
	gir1.2-javascriptcoregtk-4.0.install \
	gir1.2-webkit2-4.0.install \
	libjavascriptcoregtk-4.0-18.install \
	libjavascriptcoregtk-4.0-dev.install \
	libwebkit2gtk-4.0-37.docs \
	libwebkit2gtk-4.0-37.install \
